package acac;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;


public class ClassifyAndEMAnalysis 
{
	static private FileWriter fstream_classification;
	static private BufferedWriter out_classification;
	static private FileWriter fstream_em;
	static private BufferedWriter out_em;
	static private FileWriter fstream_em0;
	static private BufferedWriter out_em0;
	static String[] index = {"0.0", "1.0" , "2.0", "3.0", "4.0", "5.0"}; 
	
	static double emMax = 0.5;
	static double emMin = 0.125;
	static double descretionStep = 0.01;
	static int descretionNum = 38;
	
	
	//sbh
	static double sbhStrongMin = 4.0;
	static double sbhStrongMax = 7.0;
	static double sbhMediumMin = 13.0;
	static double sbhMediumMax = 16.0;
	static double sbhAllMin = 140.0;
	static double sbhAllMax = 160.0;
	
	//too few strong
	static double tooFewStrongThr = 2.0;
	static double tooFewStrongAllMin = 135.0;
	
	//too many strong
	static double tooManytrongThr = 7.0;
	
	//all weak
	static double allWeakThrStrong = 0.5;
	static double allWeakThrMedium = 0.5;
	static double allWeakThrWeak = 170;
	
	static int sbh_type = 0;
	static int tooFewStrong_type = 1;
	static int tooManyStrong_type = 2;
	static int allWeak_type = 3;
	static int other_type = 4;
	
	
	
	
	public static void main(String[] args) 
	throws IOException 
	{
		int[] classification = new int[5]; 
		int[] emr0 = new int[descretionNum]; 
		fstream_classification = new FileWriter(Summary.path + "classification.txt");
        out_classification = new BufferedWriter(fstream_classification);
        out_classification.append("rescouse-wellBeing-alliance-risk-stress,group\n"); 
        
		fstream_em = new FileWriter(Summary.path + "em-analysis.txt");
        out_em = new BufferedWriter(fstream_em);     
		fstream_em0 = new FileWriter(Summary.path + "em-analysis0.txt");
        out_em0 = new BufferedWriter(fstream_em0);  
        
		for(int i1 = 0; i1 <= 5; i1++)
		{
			for(int i2 = 0; i2 <= 5; i2++)
			{
				for(int i3 = 0; i3 <= 5; i3++)
				{
					for(int i4 = 0; i4 <= 5; i4++)
					{
						for(int i5 = 0; i5 <= 5; i5++)
						{
							String file = index[i1] + "-" + 
					  			index[i2] + "-" + index[i3] + "-" + 
					  			index[i4] + "-" + index[i5];
							try
							{
								FileInputStream in = new FileInputStream(Summary.path
										+ file + ".txt");
								out_classification.append(file + ",");
								BufferedReader br = 
									new BufferedReader(new InputStreamReader(in));
							    String tmp = null;		
							    boolean cont = true;
							    String[] infLine = null;
							    while (cont && (tmp = br.readLine()) != null)
							    {
							    	String[] ss = tmp.split(",");
							    	if(ss != null && ss.length > 0 && ss[0].equals("50"))
							    	{
							    		infLine = ss;
							    		cont = false;
							    	}
							    }				
							    double strongTies = Double.parseDouble(infLine[4]);
							    double mediumTies = Double.parseDouble(infLine[5]);
							    double weakTies = Double.parseDouble(infLine[6]);
							    double allTies = Double.parseDouble(infLine[7]);
							    
							    classification[classify(strongTies, mediumTies,
										weakTies, allTies)]++;	
							    cont = true;
							    while (cont && (tmp = br.readLine()) != null)
							    {
							    	String[] ss = tmp.split(",");
							    	if(ss != null && ss.length > 0 && ss[0].equals("50"))
							    	{
							    		infLine = ss;
							    		cont = false;
							    	}
							    }			
							    cont = true;
							    while (cont && (tmp = br.readLine()) != null)
							    {
							    	String[] ss = tmp.split(",");
							    	if(ss != null && ss.length > 0 && ss[0].equals("50"))
							    	{
							    		infLine = ss;
							    		cont = false;
							    	}
							    }						
							    double emr = Double.parseDouble(infLine[1]);
							    out_em.append(emr + "," + strongTies + "," + allTies + "\n");
							    
							    emr0[getEMRIndex(emr)]++;
							    in.close();
							}	
							catch(FileNotFoundException e1)
							{
								
							}
							catch (Exception e)
							{								
								out_classification.append("\n");	
							}
						}
					}
				}
			}
		}
		
		out_classification.append("\n");	
		out_classification.append("\n");	

		out_classification.append("sbh," + classification[sbh_type] + "\n");	
		out_classification.append("too few strong," + classification[tooFewStrong_type] + "\n");	
		out_classification.append("too many strong," + classification[tooManyStrong_type] + "\n");	
		out_classification.append("all weak," + classification[allWeak_type] + "\n");	
		out_classification.append("other," + classification[other_type] + "\n");	
		out_classification.close();
		
		out_em.close();
		
		for(int i = 0; i < descretionNum; i++)
		{
			out_em0.append(emr0[i] + "\n");
		}
		out_em0.close();
		
		System.out.print("finished");

	}

	private static int classify(double strongTies, double mediumTies,
			double weakTies, double allTies) 
	throws IOException
	{
		if((allTies > sbhAllMin && allTies < sbhAllMax)
				&& (mediumTies > sbhMediumMin && mediumTies < sbhMediumMax)
				&&(strongTies > sbhStrongMin && strongTies < sbhStrongMax))
		{
			out_classification.append("sbh" + "\n");	
			return sbh_type;
		}
		else if(strongTies > tooManytrongThr)
		{
			out_classification.append("too many strong" + "\n");	
			return tooManyStrong_type;
		}
		else if(strongTies < tooFewStrongThr && allTies < tooFewStrongAllMin)
		{
			out_classification.append("too few strong" + "\n");
			return tooFewStrong_type;
		}
		else if(strongTies < allWeakThrStrong
				&& mediumTies < allWeakThrMedium)
//				&& allTies > allWeakThrWeak)
		{
			out_classification.append("all weak ties" + "\n");	
			return allWeak_type;
		}
		else
		{
			out_classification.append("other" + "\n");	
			return other_type;
		}
	}
	
	private static int getEMRIndex(double emr)
	{
		return (int)Math.floor((emr - emMin) / descretionStep);
	}
}
