package acac;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Paint;
import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;

import javax.swing.JFrame;

import org.apache.commons.collections15.Transformer;

import edu.uci.ics.jung.algorithms.layout.ISOMLayout;
import edu.uci.ics.jung.algorithms.layout.Layout;
import edu.uci.ics.jung.graph.DirectedSparseMultigraph;
import edu.uci.ics.jung.visualization.BasicVisualizationServer;
import edu.uci.ics.jung.visualization.decorators.ToStringLabeller;
import edu.uci.ics.jung.visualization.renderers.Renderer.VertexLabel.Position;

public class DrawNetwork30Focal  
{
	static int degree = 1;
	int edgeCount;
	DirectedSparseMultigraph g;
	static String thr = "65";
	
	static String path = "D://workspace//ACAC//" + thr + "-Net//";
	static String file = "2.0-2.0-5.0-1.0-3.0-" + thr + "-30Focals.txt";
	List<Integer> nodeList;
	List<int[]> edges; 
	int nodeCount;
	
	Integer getNode(int id)
	{
		for(int i = 0; i < nodeList.size(); i++)
		{
			if(nodeList.get(i).intValue() == id)
			{
				return nodeList.get(i);
			}
		}

		nodeCount++;
		Integer n = new Integer(id);
		nodeList.add(n);
		return n;
	}


	void drawEdge(Integer startNode, Integer endNode)
	{
		if(!containEdge(startNode.intValue(), endNode.intValue()))	
		{			
//			g.addEdge(new MyLink(1, 1),new Integer(startNode.id), new Integer(endNode.id)); 
			g.addEdge(new String(String.valueOf(edgeCount)),startNode, endNode);
			edgeCount++;
			int[] e = new int[2];
			e[0] = startNode.intValue();
			e[1] = endNode.intValue();
			edges.add(e);
		}
	}
	
	boolean containEdge(int id0, int id1)
	{
		for(int i = 0; i < edges.size(); i++)
		{
			int[] edge = edges.get(i);
			if((edge[0] == id0 && edge[1] == id1) 
					|| (edge[0] == id1 && edge[1] == id0))
			{
				return true;
			}
		}
		return false;
	}
	
	void constructNetork() 
	throws IOException
	{
		nodeList = new ArrayList<Integer>();
		edges = new ArrayList<int[]>();
		FileInputStream in = new FileInputStream(path + file);
		BufferedReader br = new BufferedReader(new InputStreamReader(in));
		
		String s;// = br.readLine();
		edgeCount = 0;
		nodeCount = 0;
		g = new DirectedSparseMultigraph<Integer, String>();
		
		int c = 0;
		String[] ss;// = s.split(" ");
//		int stopID = Integer.parseInt(ss[2]);
//		int nextStopID = -1;
		while((s = br.readLine()) != null && c < degree)
		{
			try
			{
				ss = s.split(" ");
				int startID = Integer.parseInt(ss[1]);
				Integer startNode = getNode(startID);
				String[] ss1 = ss[ss.length-1].split(",");
//				nextStopID = Integer.parseInt(ss1[ss1.length - 1]);

				for(int i = 0; i < ss1.length; i++)
				{
					int endID = Integer.parseInt(ss1[i]);
					Integer endNode = getNode(endID);
					drawEdge(startNode, endNode);
				}
//				if(startID == stopID)
//				{
//					c++;
//					stopID = nextStopID;
//				}			
			}
			catch (Exception e)
			{
				System.out.println();
			}
		}
		System.out.println("node = " + this.nodeCount);
		System.out.println("edge = " + this.edgeCount);	
	}
	/**
	 * @param args
	 * @throws IOException 
	 */
	public static void main(String[] args) 
	throws IOException 
	{
		DrawNetwork30Focal sgv = new DrawNetwork30Focal(); // This builds the graph
		sgv.constructNetork();
		Layout<Integer, String> layout = new ISOMLayout(sgv.g);
		layout.setSize(new Dimension(500,300));
		BasicVisualizationServer<Integer,String> vv =
		new BasicVisualizationServer<Integer,String>(layout);
		vv.setPreferredSize(new Dimension(550,350));
		Transformer<Integer,Paint> vertexPaint = new Transformer<Integer,Paint>() {
		public Paint transform(Integer i) 
		{
			return Color.white;
		}};
		
		vv.getRenderContext().setVertexFillPaintTransformer(vertexPaint);
		vv.getRenderContext().setVertexLabelTransformer(new ToStringLabeller());
		vv.getRenderer().getVertexLabelRenderer().setPosition(Position.CNTR);
		JFrame frame = new JFrame("threshold = " + thr + ", degree = " + degree);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.getContentPane().add(vv);
		frame.pack();
		frame.setVisible(true);		
	}
}
