package acac;
//import java.io.IOException;
import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;


public class Ego implements Cloneable 
{
	public double scorewellbeing;
	public double scoreResource;
	public double scoreAlliance;
	public double scoreRisk;
	public double scoreStress;
//	private static final double DEFAULT_EAT_RATIO = 0.25d;
	private int id;
	private double eatCount;
	private double meetCount;
//	public double fitness;
	private double fitnessWellBeing;
	private double fitnessResource; 
	private double fitnessRisk; 
	private double fitnessAlliance; 
	private double fitnessStress; 
	private List<MeetLOG> allMeetLog;
	private List<MeetLOG> kinsMeetLog;
	//TODO newly added blacklist
	private List<Ego> blackList;
	private int interIteration;
	private int strongTies;
	private int weakTies;
	private double trust;
	private double trustStrong;
	private double trustWeak;
	
	private Map<Integer, double[]> trustTrace;
	private boolean isTrustTrace;
	private int currentMetID;
	private boolean metSucceed;
	private String[] actionTrace;
	
	
	//eat ratio
	private double eatRatio;		
	//eat ratio
//	private double minDefectRate;
	
	
	
	
	//policies
	//1. strong ties preferred
	private boolean strongTiesPreferred;
	//2. weak ties preferred
	private boolean weakTiesPreferred;
	//3. stage preferred
	private boolean stagePreferred;
	//4. medium preferred
	private boolean mediumPreferred;
	//5. shuffle preferred
	private boolean shufflePreferred;
	
	//defect policy
	private int defectMode;
	private double constantDefectRate;
	
	
	Ego(int id)
	{
		this.id = id;
		eatCount = 0;
		meetCount = 0;
		
		allMeetLog = new ArrayList<MeetLOG>();
		kinsMeetLog = new ArrayList<MeetLOG>();
		interIteration = 0;
		
		strongTiesPreferred = false;
		weakTiesPreferred = false;
		stagePreferred = false;
		mediumPreferred = false;
		shufflePreferred = false;	
		
		fitnessResource = 0;
		fitnessWellBeing = 0;
		fitnessRisk = 0;
		fitnessAlliance = 0; 
		fitnessStress = 0; 
		interIteration = 0;
		
		blackList = new ArrayList<Ego>();
	}	
	
	Ego(int id, Ego ego)
	{
		this.id = id;
		eatCount = 0;
		meetCount = 0;
		
//		minDefectRate = ego.getDefectRate();
		eatRatio = ego.getEatMeetRatio();	
		
		allMeetLog = new ArrayList<MeetLOG>();
		kinsMeetLog = new ArrayList<MeetLOG>();		
		interIteration = 0;	
		
		strongTiesPreferred = ego.isStrongTiesPreferred();
		weakTiesPreferred = ego.isWeakTiesPreferred();
		stagePreferred = ego.isStagePreferred();
		mediumPreferred = ego.isMediumTiesPreferred();
		shufflePreferred = ego.isShufflePreferred();
		
		fitnessResource = 0;
		fitnessWellBeing = 0;
		fitnessRisk = 0;
		fitnessAlliance = 0; 
		fitnessStress = 0; 
		interIteration = 0;
		
		setDefection(ego.getdefectMode(), ego.getConstantDefectRate());
		
		blackList = new ArrayList<Ego>();
	}

	public void setEatRatio(double eatRatio)
	{
		this.eatRatio = eatRatio;
	}
	

//	public void setMinDefectRate(double minDefectRate)
//	{
//		this.minDefectRate = minDefectRate;
//	}
	
	public void setTrustTrace()
	{
		isTrustTrace = true;
		trustTrace = new HashMap<Integer, double[]>();
		actionTrace = new String[Sociaty.iterations];
	}
	
	public void reset()
	{			
		eatCount = 0;
		meetCount = 0;
		fitnessResource = 0;
		fitnessWellBeing = 0;
		fitnessRisk = 0;
		fitnessAlliance = 0; 
		fitnessStress = 0; 
		fitnessAlliance = 0; 
		fitnessStress = 0; 
		interIteration = 0;
		strongTies = 0;
		weakTies = 0;
		trust = 0;
		fitnessRisk = 0;
		fitnessStress = 0;
		trustStrong = 0;
		trustWeak = 0;

		blackList.clear();
		MeetLOG log = null;
		allMeetLog.clear();
		for(int i = 0; i < kinsMeetLog.size(); i++)
		{
			log = kinsMeetLog.get(i);
			if(log.getTrust() >= Sociaty.strongTiesThr)
			{
				double newTrust = Math.max(Sociaty.trustThrKins,log.getTrust());
				log.setTrust(newTrust);
				log.setTrustIn(newTrust);
				log.setTrustOut(newTrust);
				allMeetLog.add(log);
			}
			else
			{
				kinsMeetLog.remove(i);
				i--;
			}
		}
	}
	
	public List<MeetLOG> getAllMeetLog()
	{
		return allMeetLog;
	}
	
	public List<MeetLOG> getKinsMeetLog()
	{
		return kinsMeetLog;
	}
	
	public double getMeetCount()
	{
		return meetCount;
	}
	
	public double getEatCount()
	{
		return eatCount;
	}
	
	public int getInterIteration()
	{
		return interIteration;
	}

	public void setStrongTiesPreferred()
	{
		strongTiesPreferred = true;
	}
	
	public void setMediumTiesPreferred()
	{
		mediumPreferred = true;
	}
	public void setDefection(int defectMode, double constantDefectRate)
	{
		this.defectMode = defectMode;
		this.constantDefectRate = constantDefectRate;
	}
	public void setShufflePreferred()
	{
		shufflePreferred = true;
	}
	public void setWeakTiesPreferred()
	{
		weakTiesPreferred = true;
	}
	public void setStagePreferred()
	{
		stagePreferred = true;
	}
	public boolean isStrongTiesPreferred()
	{
		return strongTiesPreferred;
	}
	public boolean isWeakTiesPreferred()
	{
		return weakTiesPreferred;
	}
	public boolean isStagePreferred()
	{
		return stagePreferred;
	}
	public boolean isMediumTiesPreferred()
	{
		return mediumPreferred;
	}
	public boolean isShufflePreferred()
	{
		return shufflePreferred;
	}
	
	public void runATurn(List<Ego> egoes, int g, int i) throws Exception
	{
		double rand = Math.random();
		this.clearZeroTrustTies();
		if(rand < eatRatio)
		{
			eat();
			metSucceed = false;
			if(isTrustTrace)
			{
				actionTrace[i]="eat";
			}			
		}
		else
		{
			meet(egoes, g, i);
			if(isTrustTrace)
			{
				actionTrace[i] = "meet "+currentMetID;
				if(metSucceed)
				{
					actionTrace[i] += " cooperated";
				}
				else
				{
					actionTrace[i] += " rejected";
				}
			}		
		}		
		//calculate fitness and update eat/meet ratio
		calculateFitness();		
		interIteration++;	
		
		//trace trust
		if(isTrustTrace)
		{
			double[] trusts = null;
			MeetLOG log = null;
			int logID;
			for(int j = 0; j < allMeetLog.size(); j++)
			{
				log = allMeetLog.get(j);
				logID = log.getID();				
				Iterator<Integer> it = trustTrace.keySet().iterator();
				Integer trustTraceID = null;
				boolean cont = true;
				while(cont && it.hasNext())
				{
					trustTraceID = it.next();
					if(trustTraceID.intValue() == logID)
					{
						trusts = trustTrace.get(trustTraceID);
						cont = false;
					}
				}
				if(cont)
				{
					trusts = new double[Sociaty.iterations];	
					trustTrace.put(new Integer(logID), trusts);
				}
				trusts[i] = log.getTrust();
			}
		}		
	}	
	
	public void debudPrintTrust() throws IOException
	{
		if(isTrustTrace)
		{
//number of weak and medium ties to output 
int numberWeak = 3;
int numberMedium = 3;
int weakCount = 0;
int mediumCount = 0;

			Integer trustTraceID = null;
			double[] trust = null;
			Iterator<Integer> it = trustTrace.keySet().iterator();

//			System.out.println("** this id " + id);
			while(it.hasNext())
			{
				trustTraceID = it.next();
				trust = trustTrace.get(trustTraceID);
				
				if(trust[Sociaty.iterations - 1] > Sociaty.strongTiesThr)
				{
					printOneTrace(trustTraceID, trust);
				}
				
				else if(trust[Sociaty.iterations - 1] > Sociaty.mediumTiesThr )
				{
					if(mediumCount < numberMedium)
					{
						printOneTrace(trustTraceID, trust);
						mediumCount++;			
					}		
				}
				else
				{
					if(weakCount < numberWeak)
					{
						if(mediumCount < numberMedium)
						{
							printOneTrace(trustTraceID, trust);
							weakCount++;			
						}	
					}					
				}

			}
		}
	}
	
	private void printOneTrace(Integer trustTraceID, double[] trust) 
	throws IOException
	{
        //Construct the BufferedWriter object
		String filename = id + "-" + trustTraceID.intValue() + defectMode + ".txt";
		BufferedWriter bufferedWriter = new BufferedWriter(new FileWriter(filename));
		bufferedWriter.append("ego " + trustTraceID.intValue() + "\n");
//		System.out.println(trustTraceID.intValue());
		for(int i = 0; i < Sociaty.iterations; i++)
		{
//			System.out.print(trust[i] + ",");
			bufferedWriter.append(trust[i] + "\n");
//			String[] ss = actionTrace[i].split(" ");
//			if(ss.length > 2 && Integer.parseInt(ss[1]) == trustTraceID.intValue())
//			{
////				bufferedWriter.append(ss[2] + " " + ss[1] + "\n");
////				System.out.println(ss[2] + " " + ss[1]);
//			}
//			else
//			{
//				bufferedWriter.append("\n");
////				System.out.println("");
//			}
		}
		bufferedWriter.close();
	}
	
	public double getStrongTrust()
	{
		double st = 0.0d;
		int c = 0;
		for(int i = 0; i < allMeetLog.size(); i++)
		{
			double t = allMeetLog.get(i).getTrust();
			if(t >= Sociaty.strongTiesThr)
			{
				st += t;
				c++;
			}
		}
		
		if(c > 0)
		{
			return st / c;
		}
		else
		{
			return 0;
		}
	}
	
	public double getWeakTrustWithoutMediumTies()
	{
		return trustWeak;
	}
	
	public double getWeakTrustWithMediumTies()
	{
		double wt = 0.0d;
		int c = 0;
		for(int i = 0; i < allMeetLog.size(); i++)
		{
			double t = allMeetLog.get(i).getTrust();
			if(t < Sociaty.mediumTiesThr)
			{
				wt += t;
				c++;
			}
		}
		if(c > 0)
		{
			return wt / c;
		}
		else
		{
			return 0;
		}
		
	}
	
	public double getMediumTrust()
	{
		double mt = 0.0d;
		int c = 0;
		for(int i = 0; i < allMeetLog.size(); i++)
		{
			double t = allMeetLog.get(i).getTrust();
			if(t >= Sociaty.mediumTiesThr && t < Sociaty.strongTiesThr)
			{
				mt += t;
				c++;
			}
		}
		
		if(c > 0)
		{
			return mt / c;
		}
		else
		{
			return 0;
		}
		
	}
	
	public double getTrust()
	{
		return trust;
	}

	public void removeLog(int removedID)
	{
		boolean cont = true;
		for(int i = 0; cont && i < allMeetLog.size(); i++)
		{
			MeetLOG log = allMeetLog.get(i);
			if(log.getID() == removedID)
			{
				allMeetLog.remove(log);
				cont = false;
			}
		}		
		
		cont = true;
		for(int i = 0; cont && i < kinsMeetLog.size(); i++)
		{
			MeetLOG log = kinsMeetLog.get(i);
			if(log.getID() == removedID)
			{
				kinsMeetLog.remove(log);
				cont = false;
			}
		}
		calculateFitness();
	}
	
	public void calculateFitness()
	{
		clearZeroTrustTies();
		
		double totalIn = 0.0d;
		double totalOut = 0.0d;
		
		fitnessWellBeing = 0;
		strongTies = 0;
		trust = 0;
		fitnessRisk = 0;
		fitnessStress = 0;
		trustStrong = 0;
		trustWeak = 0;
		double averageTrust = 0;
		int ties = 0;
		if(allMeetLog.size() > 0)
		{
			for(int i = 0; i < allMeetLog.size(); i++)
			{ 
				if(allMeetLog.get(i).getTrust()> 0)
				{
					ties++;
				}
				
				if(allMeetLog.get(i).getTrust() >= Sociaty.strongTiesThr)
				{
					strongTies++;
					trustStrong += allMeetLog.get(i).getTrust();
				}	
				else
				{
					trustWeak += allMeetLog.get(i).getTrust();
				}
				trust += allMeetLog.get(i).getTrust();
//				fitnessRisk += allMeetLog.get(i).getRisk();
				totalIn += allMeetLog.get(i).getIn();
				totalOut += allMeetLog.get(i).getOut();
				fitnessWellBeing += allMeetLog.get(i).getTrust();
			}
			averageTrust = fitnessWellBeing / ties;
			fitnessWellBeing = (fitnessWellBeing * totalIn / totalOut) / ties;
			if(Double.isInfinite(fitnessWellBeing))
			{
				fitnessWellBeing = 0;
			}
			
		}
		weakTies = ties - strongTies;
		fitnessResource = (1 + allMeetLog.size() / 3) * eatCount / 100.0;
		fitnessRisk = averageTrust + 0.005 * meetCount;
		fitnessAlliance = averageTrust + 0.05 * ties;
		fitnessStress = 0.1 * ties;
		clearZeroTrustTies();
		
	}
	
	private void clearZeroTrustTies()
	{
		for(int i = 0; i < allMeetLog.size(); i++)
		{
			if(allMeetLog.get(i).getTrust() <= 0)
			{
				allMeetLog.remove(i);
				i--;
			}
		}
	}

	public int getStrongTies()
	{
		int st = 0;
		for(int i = 0; i < allMeetLog.size(); i++)
		{
			if(allMeetLog.get(i).getTrust() > Sociaty.strongTiesThr)
			{
				st++;
			}
		}
		return st;
	}
	
	public int getMediumTies()
	{
		int mt = 0;
		for(int i = 0; i < allMeetLog.size(); i++)
		{
			if(allMeetLog.get(i).getTrust() > Sociaty.mediumTiesThr)
			{
				mt++;
			}
		}
		return mt - strongTies;
	}
	
//version 1 without medium ties	
	public int getWeakTiesWithoutMudium()
	{
		return weakTies;
	}
//version 2 with medium ties	
	public int getWeakTiesWithMudium()
	{
		int wt = 0;
		for(int i = 0; i < allMeetLog.size(); i++)
		{
			if(allMeetLog.get(i).getTrust() <= Sociaty.mediumTiesThr)
			{
				wt++;
			}
		}
		return wt;
	}
	private void eat()
	{
		eatCount++;
	}
	
	public void addKins(Ego ego)
	{
		MeetLOG meetLog = new MeetLOG(ego.getID());
		meetLog.setTrust(Sociaty.trustThrKins);
		meetLog.setTrustIn(Sociaty.trustThrKins);
		meetLog.setTrustOut(Sociaty.trustThrKins);
		if(!hasKin(ego))
		{
			kinsMeetLog.add(meetLog);
		}
	}
	
	public int getNumberKins()
	{
		return kinsMeetLog.size();
	}
	
	private void meetStrong(List<Ego> egoes)
	{				
		double totalTrust = 0.0d;
		MeetLOG[] tmpLog = new MeetLOG[allMeetLog.size()];			
		for(int i = 0; i < allMeetLog.size(); i++)
		{
			totalTrust += allMeetLog.get(i).getTrust();
			tmpLog[i] =  allMeetLog.get(i);
		}
		Arrays.sort(tmpLog);
		int selectedID = -1;
		double tmpTrust = 0.0d;
		double rand = Math.random() * totalTrust;
		boolean cont = true;
		for(int i = allMeetLog.size() - 1; cont && i >= 0; i--)
		{	
			tmpTrust += tmpLog[i].getTrust();
			if(rand <= tmpTrust)
			{
				selectedID = tmpLog[i].getID();
				cont = false;
			}
		}		
		tryToMeet(egoes, selectedID);
		
//		Ego SelectedEgo = null;
//		cont = true;
//		for(int i = 0; cont && i< egoes.size(); i++)
//		{
//			if(egoes.get(i).getID() == selectedID)
//			{
//				SelectedEgo = egoes.get(i);
//				cont = false;
//			}
//		}
//		if(SelectedEgo.cooperate(this))
//		{
//			addMeetLogOut(SelectedEgo);
//		}
//		else
//		{
////			rejectMeetLog(SelectedEgo);
//		}
	}
	private void meetMedium(List<Ego> egoes)
	{		
		//meet medium
		double totalTrust = 0.0d;
		MeetLOG[] tmpLog = new MeetLOG[allMeetLog.size()];			
		for(int i = 0; i < allMeetLog.size(); i++)
		{
			totalTrust += allMeetLog.get(i).getTrust();
			tmpLog[i] =  allMeetLog.get(i);
		}
		
		double halfTrust = totalTrust / 2;
		boolean cont = true;			
		double tmpTrust = 0.0d;		
		double preHalfTrust = 0.0d;
		int middlePos = -1;			
		
		Arrays.sort(tmpLog);				
		//find half trust position as medium, 
		//which is the beginning of the lower part (strong preferred)
		//above is weak preferred
		for(int i = 0; cont && i < tmpLog.length; i++)
		{
			preHalfTrust += tmpLog[i].getTrust();
			if(preHalfTrust >= halfTrust)
			{
				middlePos = i;
				preHalfTrust -= tmpLog[i].getTrust();
				cont = false;						
			}
		}
		
		
		int selectedID = -1;
		double rand = Math.random() * totalTrust;
		
		if(rand <= preHalfTrust)
		{				
			tmpTrust = 0.0d;
			cont = true;
			//for half strong preferred;
			for(int i = 0; cont && i < middlePos; i++)
			{
				tmpTrust += tmpLog[i].getTrust();
				if(rand <= tmpTrust)
				{
					selectedID = tmpLog[i].getID();
					cont = false;
				}
			}					
		}
		else
		{
			tmpTrust = preHalfTrust;
			cont = true;
			//for half weak preferred;
			for(int i = middlePos; cont && i < tmpLog.length; i++)
			{
				tmpTrust += tmpLog[i].getTrust();
				if(rand <= tmpTrust)
				{
					selectedID = tmpLog[allMeetLog.size() - 1 - i].getID();
					cont = false;
				}
			}
		}		
		
		tryToMeet(egoes, selectedID);
		

	}

	private void meetWeak(List<Ego> egoes)
	{		
		double totalTrust = 0.0d;
		MeetLOG[] tmpLog = new MeetLOG[allMeetLog.size()];			
		for(int i = 0; i < allMeetLog.size(); i++)
		{
			totalTrust += allMeetLog.get(i).getTrust();
			tmpLog[i] =  allMeetLog.get(i);
		}
		Arrays.sort(tmpLog);
		int selectedID = -1;
		double tmpTrust = 0.0d;
		double rand = Math.random() * totalTrust;
		boolean cont = true;
		for(int i = allMeetLog.size() - 1; cont && i >= 0; i--)
		{	
			tmpTrust += tmpLog[i].getTrust();
			if(rand <= tmpTrust)
			{
				selectedID = tmpLog[allMeetLog.size() - 1 - i].getID();
				cont = false;
			}
		}		
		
		tryToMeet(egoes, selectedID);		

	}
	
	private void meetNew(List<Ego> egoes)
	{		
		Ego SelectedEgo = null;
		double rand = Math.random() * (Sociaty.population - allMeetLog.size() - blackList.size() - 1);
		int count = 0;
		boolean cont = true;
		for(int i = 0; cont && i < egoes.size(); i++)
		{
//			if(egoes.get(i).getID() != id)
			//add blacklist
			if(egoes.get(i).getID() != id && !blackList.contains(egoes.get(i)))
			{
				boolean interCont = true;
				for(int j = 0; interCont && j < allMeetLog.size(); j++)
				{
					if(egoes.get(i).getID() == allMeetLog.get(j).getID())
					{
						interCont = false;
					}
				}
				if(interCont)
				{
					count++;
					if(rand < count)
					{
						SelectedEgo = egoes.get(i);
						cont = false;
					}
				}
			}
		}
		currentMetID = SelectedEgo.getID();
		if(SelectedEgo.cooperate(this))
		{
			addMeetLogOut(SelectedEgo);
			metSucceed = true;
		}
		else
		{
			rejectMeetLog(SelectedEgo);
			metSucceed = false;
		}
	}

	private void meetStage(List<Ego> egoes) throws Exception
	{		
		double totalLeftSteps = Sociaty.iterations - interIteration;
		MeetLOG[] tmpLog = new MeetLOG[allMeetLog.size()];
		double totalTrust = 0.0d;
		for(int i = 0; i < tmpLog.length; i++)
		{
			tmpLog[i] = allMeetLog.get(i);
			totalTrust += tmpLog[i].getTrust();
		}
		Arrays.sort(tmpLog);
		
		double rand = Math.random() * totalTrust;
		double chance = 0.0d;
		boolean cont = true;
		for(int i = 0; cont && i < tmpLog.length; i++)
		{
			chance += tmpLog[i].getTrust() - (tmpLog[i].getTrust() - 
					tmpLog[tmpLog.length - i - 1].getTrust()) / totalLeftSteps;
			if(rand < chance)
			{
				int selctedID = tmpLog[i].getID();
				Ego SelectedEgo = null;
				boolean interCont = true;
				for(int j = 0; interCont && j < egoes.size(); j++)
				{
					if(egoes.get(j).getID() == selctedID)
					{
						SelectedEgo = egoes.get(j);
						interCont = false;
					}
				}

				currentMetID = SelectedEgo.getID();
				if(SelectedEgo.cooperate(this))
				{
					addMeetLogOut(SelectedEgo);
					metSucceed = true;
				}
				else
				{
					rejectMeetLog(SelectedEgo);
					metSucceed = false;
				}
				cont = false;
			}
		}		
		if(cont)
		{
			throw new Exception();
		}
	}
	
	private void meetCompletelyRandomly(List<Ego> egoes)
	{		
		int selectedIndex = (int)Math.floor(Math.random() * egoes.size());
//		while(egoes.get(selectedIndex).getID() == id)
		//TODO add blacklist
		while(egoes.get(selectedIndex).getID() == id 
				|| blackList.contains(egoes.get(selectedIndex)))
		{
			selectedIndex = (int)Math.floor(Math.random() * egoes.size());
		}
		Ego SelectedEgo = egoes.get(selectedIndex);
		currentMetID = SelectedEgo.getID();
		if(SelectedEgo.cooperate(this))
		{
			addMeetLogOut(SelectedEgo);
			metSucceed = true;
		}
		else
		{
			rejectMeetLog(SelectedEgo);
			metSucceed = false;
		}
	}
	
	private void meet(List<Ego> egoes, int generation, int iteration) throws Exception
	{
		if(allMeetLog.size() == 0)
		{
			//seeding
			meetCompletelyRandomly(egoes);
		}	
		else
		{
			double rand0 = Math.random();
			if((rand0 > allMeetLog.size() / (double)Sociaty.population) 
					&& (allMeetLog.size() < Sociaty.population - 1))
			{
				meetNew(egoes);
			}
			else
			{				
				if(strongTiesPreferred)
				{
					meetStrong(egoes);
				}
				else if(weakTiesPreferred)
				{
					meetWeak(egoes);
				}
				else if(stagePreferred)
				{
					meetStage(egoes);
				}
				else if(mediumPreferred)
				{
					meetMedium(egoes);
				}
				else if(shufflePreferred)
				{
					int x = iteration % 2;
					if(x == 0)
					{
						meetStrong(egoes);
					}
					else if(x == 2)
					{
						meetMedium(egoes);
					}
//					else if(x == 3)
//					{
//						meetWeak(egoes);
//					}
					else
					{
						//nothing is done;
					}
				}
				else
				{
					double totalSteps = (Sociaty.generations - generation) 
							* Sociaty.iterations - iteration + interIteration;
					if(Math.random() <= (double)interIteration / totalSteps)
					{
						meetExisting(egoes);
					}
					else
					{
						meetCompletelyRandomly(egoes);
					}
				}
			}

		}
	}
	
	private void meetExisting(List<Ego> egoes)
	{	
		MeetLOG[] tmpMeetLog = new MeetLOG[allMeetLog.size()];
		for(int i = 0; i < allMeetLog.size(); i++)
		{
			tmpMeetLog[i] = allMeetLog.get(i);
		}
		Arrays.sort(tmpMeetLog);

		double totalTrust = 0.0d;
		if( Math.random() < 0.25)
		{
			for(int i = 0; i < allMeetLog.size(); i++)
			{
				totalTrust += tmpMeetLog[i].getTrust();
			}
		}
		else
		{
			for(int i = 0; i < (double)allMeetLog.size() / 2; i++)
			{
				totalTrust += tmpMeetLog[i].getTrust();
			}
		}
		
		double tmpTrust = 0.0d;
		double rand = Math.random() * totalTrust;
		int i;
		for(i = 0; rand < tmpTrust && i < allMeetLog.size(); i++)
		{
			tmpTrust += tmpMeetLog[i].getTrust();
		}
		
		tryToMeet(egoes, tmpMeetLog[i].getID());
		
//		int SelectedEgoIndex = tmpMeetLog[i].getID();
//		Ego SelectedEgo = null;
//		boolean cont = true;
//		for(i = 0; cont && i < egoes.size(); i++)
//		{
//			if(egoes.get(i).getID() == SelectedEgoIndex)
//			{
//				SelectedEgo = egoes.get(i);
//				cont = false;
//			}
//		}
//		if(SelectedEgo.cooperate(this))
//		{
//			addMeetLogOut(SelectedEgo);
//		}
//		else
//		{
//			rejectMeetLog(SelectedEgo);
//		}	

	}
	

	private void tryToMeet(List<Ego> egoes, int selectedID)
	{
		Ego SelectedEgo = null;
		boolean cont = true;
		for(int i = 0; cont && i < egoes.size(); i++)
		{
			if(egoes.get(i).getID() == selectedID)
			{
				SelectedEgo = egoes.get(i);
				cont = false;
			}
		}	
		currentMetID = SelectedEgo.getID();
		if(SelectedEgo.cooperate(this))
		{
			addMeetLogOut(SelectedEgo);	
			metSucceed = true;
		}
		else
		{
			rejectMeetLog(SelectedEgo);
			metSucceed = false; 
		}	
	}	
		
	private boolean cooperate(Ego focal)
	{
		
		if(Sociaty.DEFENSE)
		{
			//calculate defense probability defence policy and penalty
			double denfenseProability = 0.0d;
			int focalID = focal.getID();
			boolean cont = true;
			for(int i = 0; cont && i< allMeetLog.size(); i++)
			{
				if(allMeetLog.get(i).getID() == focalID)
				{
//					denfenseProability = Math.max(minDefectRate,
//							allMeetLog.get(i).getDefenseProb(defectMode, constantDefectRate));
					denfenseProability = 
							allMeetLog.get(i).getDefenseProb(defectMode, constantDefectRate);
					cont = false;
				}
			}
			double r = Math.random();
			if(r < denfenseProability)
			{
				if(Sociaty.symmetrical)
				{
					rejectMeetLog(focal);
					if(Sociaty.rewardDefection)
					{
						eatCount++;
					}
				}
				return false;
			}
			else
			{
				meetCount++;
				addMeetLogIn(focal);
				return true;
			}			
		}
		else
		{
			meetCount++;
			addMeetLogIn(focal);
			return true;
		}
	}

	private void addMeetLogIn(Ego ego)
	{
		boolean added = false;
		
		//TODO add blacklist
		if(this.blackList.contains(ego))
		{
			blackList.remove(ego);
		}
		
		for(int i = 0; !added && i < allMeetLog.size(); i++)
		{
			if(ego.getID() == allMeetLog.get(i).getID())
			{
				allMeetLog.get(i).increaseTrust();
				allMeetLog.get(i).increaseTrustIn();
				allMeetLog.get(i).addIn();
				added = true;
			}
		}
		if(!added)
		{
			//create a new log to add
			MeetLOG log = new MeetLOG(ego.getID());  
			log.increaseTrust();
			log.increaseTrustIn();
			log.addIn();
			allMeetLog.add(log);
		}
	}
	
	private void addMeetLogOut(Ego ego)
	{
		boolean added = false;
		for(int i = 0; !added && i < allMeetLog.size(); i++)
		{
			if(ego.getID() == allMeetLog.get(i).getID())
			{
				allMeetLog.get(i).increaseTrust();
				allMeetLog.get(i).increaseTrustOut();
				allMeetLog.get(i).addOut();
				added = true;
			}
		}
		if(!added)
		{
			//create a new log to add
			MeetLOG log = new MeetLOG(ego.getID());  
			log.increaseTrust();
			log.increaseTrustOut();
			log.addOut();
			allMeetLog.add(log);
		}
	}
	
	private void rejectMeetLog(Ego ego)
	{
		boolean rejected = false;
		for(int i = 0; !rejected && i < allMeetLog.size(); i++)
		{
			if(ego.getID() == allMeetLog.get(i).getID())
			{
				allMeetLog.get(i).decreaseTrust();
				allMeetLog.get(i).decreaseTrustOut();
				allMeetLog.get(i).increaseBeRejected();
				rejected = true;
			}
		}
		if(!rejected)
		{
			//create a new log to add
			MeetLOG log = new MeetLOG(ego.getID());  
			log.decreaseTrust();
			log.decreaseTrustOut();
			log.increaseBeRejected();
			allMeetLog.add(log);
			//TODO added blacklist
			blackList.add(ego);
		}
	}

	public void mutate()
	{
		//mutation on eat/meet ratio
		double r = Math.random();
		if(r < 0.3333d)
		{
			int slot = (int)Math.floor(Math.random() * Sociaty.mutationSlots);
			eatRatio  = Sociaty.minEMR + slot * Sociaty.gradEMR;
//			int index = (int)Math.floor(rand * Sociaty.eatMeetGenes.length);
//			if(eatRatio == Sociaty.eatMeetGenes[index])
//			{
//				if(index == Sociaty.eatMeetGenes.length - 1)
//				{
//					index--;
//				}
//				else
//				{
//					index++;
//				}
//				
//			}
//			eatRatio = Sociaty.eatMeetGenes[index];
		}
		
		//mutation on defect rate
		else if(r < 0.6666d)
		{
			int slot = (int)Math.floor(Math.random() * Sociaty.mutationSlots);
//			minDefectRate  = Sociaty.minD + slot * Sociaty.gradD;
//			double rand = Math.random();
//			int index = (int)Math.floor(rand * Sociaty.DefectGenes.length);
//			if(minDefectRate == Sociaty.DefectGenes[index])
//			{
//				if(index == Sociaty.DefectGenes.length - 1)
//				{
//					index--;
//				}
//				else
//				{
//					index++;
//				}				
//			}
//			minDefectRate = Sociaty.DefectGenes[index];
		}
		
		//mutation on strategy
		else
		{
			if(stagePreferred)
			{
				stagePreferred = false;
				double rand = Math.random();
				if(rand < 0.3333)
				{					
					strongTiesPreferred = true;
				}
				else if(rand < 0.6666)
				{
					weakTiesPreferred = true;
				}
				else
				{
					mediumPreferred = true;
				}
			}
			else if(strongTiesPreferred)
			{
				strongTiesPreferred = false;
				double rand = Math.random();
				if(rand < 0.3333)
				{					
					stagePreferred = true;
				}
				else if(rand < 0.6666)
				{
					weakTiesPreferred = true;
				}
				else
				{
					mediumPreferred = true;
				}				
			}
			else if(weakTiesPreferred)
			{
				weakTiesPreferred = false;
				double rand = Math.random();
				if(rand < 0.3333)
				{					
					stagePreferred = true;
				}
				else if(rand < 0.6666)
				{
					strongTiesPreferred = true;
				}
				else
				{
					mediumPreferred = true;
				}				
			}
			else if(mediumPreferred)
			{
				mediumPreferred = false;
				double rand = Math.random();
				if(rand < 0.3333)
				{					
					stagePreferred = true;
				}
				else if(rand < 0.6666)
				{
					weakTiesPreferred = true;
				}
				else
				{
					strongTiesPreferred = true;
				}				
			}
		}
		
	}
	
	public void tiesDecay()
	{
		for(int i = 0; i < allMeetLog.size(); i++)
		{
			allMeetLog.get(i).waning();
		}
		clearZeroTrustTies();
	}

	public boolean hasKin(Ego ego)
	{
		int egoID = ego.getID();
		for(int i = 0; i < kinsMeetLog.size(); i++)
		{
			if(egoID == kinsMeetLog.get(i).getID())
			{
				return true;
			}
		}
		return false;
	}

	public boolean hasMet(Ego ego)
	{
		int egoID = ego.getID();
		for(int i = 0; i < allMeetLog.size(); i++)
		{
			if(egoID == allMeetLog.get(i).getID())
			{
				return true;
			}
		}
		return false;
	}
	
	public int getID()
	{
		return id;
	}

	public double getEatMeetRatio()
	{
		return eatRatio;
	}
	
	public int getdefectMode()
	{
		return defectMode;
	}

	public double getConstantDefectRate()
	{
		return constantDefectRate;
	}
	
	public double getResource()
	{
		return fitnessResource;
	}

	public double getWellbeing()
	{
		return fitnessWellBeing;
	}

	public double getAlliance()
	{
		return fitnessAlliance;
	}	

	public double getRisk()
	{
		return fitnessRisk;
	}
	
	public double getStress()
	{
		return fitnessStress;
	}
	
	public double getResourceScore()
	{
		return scoreResource;
	}

	public double getWellbeingScore()
	{
		return scorewellbeing;
	}

	public double getAllianceScore()
	{
		return scoreAlliance;
	}	

	public double getRiskScore()
	{
		return scoreRisk;
	}
	
	public double getStressScore()
	{
		return scoreStress;
	}
	

	public double getScore()
	{
		return Sociaty.rescouseWeight * scoreResource
			+ Sociaty.wellBeingWeight * scorewellbeing
			+ Sociaty.allianceWeight * scoreAlliance
			+ Sociaty.riskWeight * scoreRisk
			+ Sociaty.stressWeight * scoreStress;
	}
	
	
	public double getAllTies()
	{
		return weakTies + strongTies;
	}
	
	public String getStrategy()
	{
		if(stagePreferred)
		{
			return "stage";
		}
		else if(strongTiesPreferred)
		{
			return "strong";
		}
		else if(weakTiesPreferred)
		{
			return "weak";
		}
		else if(mediumPreferred)
		{
			return "medium";
		}
		else
		{
			return null;
		}
	}
	
	public void setStrategy(String strategy)
	{
		stagePreferred = false;
		strongTiesPreferred = false;
		weakTiesPreferred = false;
		mediumPreferred = false;
		if(strategy.equals("stage"))
		{
			stagePreferred = true;
		}
		else if(strategy.equals("strong"))
		{
			strongTiesPreferred = true;
		}
		else if(strategy.equals("weak"))
		{
			weakTiesPreferred = true;
		}
		else if(strategy.equals("medium"))
		{
			mediumPreferred = true;
		}
		else
		{
			;
		}
	}
}
