package acac;

import java.awt.Color;
import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.InputStreamReader;

import javax.swing.*;

import org.math.plot.*;

import static java.lang.Math.*;


public class Plot3D 
{
	static String path = "P://project//workspace//ACEC//";	
	static String sbhFile ="Tess result.txt";
	static double[] resource;
	static double[] wellBeing;
	static double[] alliance;
	static double[] risk;
	static double[] stress;
	
	private static void readData()
	{
		int count = 0;
		try
		{		  
			FileInputStream fstream = new FileInputStream(path + sbhFile);
			DataInputStream in = new DataInputStream(fstream);
			BufferedReader br = new BufferedReader(new InputStreamReader(in));
			String strLine;
			strLine = br.readLine();
			while ((strLine = br.readLine()) != null)   
			{
				count++;
			}
			in.close();
		}
		catch (Exception e)
		{
			System.err.println("Error: " + e.getMessage());
		}
		
		resource = new double[count];
		wellBeing = new double[count];
		alliance = new double[count];
		risk = new double[count];
		stress = new double[count];

		try
		{
		  
			FileInputStream fstream = new FileInputStream(path + sbhFile);
			DataInputStream in = new DataInputStream(fstream);
			BufferedReader br = new BufferedReader(new InputStreamReader(in));
			String strLine;
			count = 0;
			strLine = br.readLine();
			while ((strLine = br.readLine()) != null)   
			{
				String[] ss = strLine.split(",");
				resource[count] = Double.valueOf(ss[0]);
				wellBeing[count] = Double.valueOf(ss[1]);
				alliance[count] = Double.valueOf(ss[2]);
				risk[count] = Double.valueOf(ss[3]);
				stress[count] = Double.valueOf(ss[4]);
				count++;
			}

			in.close();
		}
		catch (Exception e)
		{
			System.err.println("Error: " + e.getMessage());
		}
	}
	
	
	public static void main(String[] args) 
	{
//		resource-wellBeing-alliance-risk-stress
		readData();
		// create your PlotPanel (you can use it as a JPanel) with a legend at SOUTH
		double[] min = {0,0,0};
		double[] max = {10,10,5};
		String[] axesScales = {"lin", "lin", "lin"};
		String[] axesLabels = { "wellbeing-alliance", "risk-stress", "resource"};
		Plot3DPanel plot = new Plot3DPanel(min, max, axesScales, axesLabels);
		Plot2DPanel p;
		
		//resource; wellBeing; alliance; risk; stress;
		
		// add grid plot to the PlotPanel
		plot.addLegend("SBH");	
		double[] wellBeing_alliance = new double[wellBeing.length];
		double[] risk_stress = new double[wellBeing.length];
		for(int i = 0; i < wellBeing.length; i++)
		{
			wellBeing_alliance[i] = wellBeing[i] + alliance[i];
			risk_stress[i] = risk[i] + stress[i];
		}
		
		double[] referencepoints1 = {0,10};
		double[] referencepoints2 = {0,10};
		double[] referencepoints3 = {0,5};
		
		plot.addScatterPlot("SBH", Color.red, wellBeing_alliance, risk_stress, resource);
		plot.addScatterPlot("SBH", Color.white, referencepoints1, referencepoints2, referencepoints3);
//		plot.addScatterPlot("SBH", Color.red, wellBeing, alliance, resource);
//		plot.addScatterPlot("SBH", Color.blue, wellBeing, alliance, risk);
//		plot.addScatterPlot("SBH", Color.yellow, wellBeing, alliance, stress);

		// put the PlotPanel in a JFrame like a JPanel
		JFrame frame = new JFrame("SBH");
		frame.setSize(600, 600);
		frame.setContentPane(plot);
		frame.setVisible(true);
	}
	
	// function definition: z=cos(PI*x)*sin(PI*y)
	public static double f1(double x, double y) {
		double z = cos(x * PI) * sin(y * PI);
		return z;
	}

	// grid version of the function
	public static double[][] f1(double[] x, double[] y) {
		double[][] z = new double[y.length][x.length];
		for (int i = 0; i < x.length; i++)
			for (int j = 0; j < y.length; j++)
				z[j][i] = f1(x[i], y[j]);
		return z;
	}

	// another function definition: z=sin(PI*x)*cos(PI*y)
	public static double f2(double x, double y) {
		double z = sin(x * PI) * cos(y * PI);
		return z;
	}

	// grid version of the function
	public static double[][] f2(double[] x, double[] y) {
		double[][] z = new double[y.length][x.length];
		for (int i = 0; i < x.length; i++)
			for (int j = 0; j < y.length; j++)
				z[j][i] = f2(x[i], y[j]);
		return z;
	}
	
	
}

