//without risk
//trust = 0; die out
//output medium ties
//this is before decay for the next turning
//
package acac;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.List;


public class Sociaty 
{
	private boolean DEBUG = false;
	private List<Ego> egoes;
	
	public boolean SBH;
	FileWriter fstream;
    BufferedWriter out;
	
	public static final int population = 300;
	public static final int iterations = 3000;
	public static final int generations = 1;	
	
	public static boolean crossoverEM = false;
	public static boolean crossoverST = false;
	public static boolean crossoverDe = false;	
	

	public static final boolean DEFENSE = true;
	public static final boolean symmetrical = false;
	public static final boolean rewardDefection = true;
	
	public static final double constantDefectRate = 0.01;
	public static final double averageNumberKins = 0;
	public static final double trustThrKins = 80.0d;

	private static final double crossoverRate = 0.9d; 
	private static final double mutationRate = 0.01d; 
	
	public static double[] eatMeetGenesIni = {0.125, 0.2, 0.25, 0.5};
	public static double[] DefectGenesIni = {0.01, 0.025, 0.05, 0.075};
	
	public static double maxEMR = 0.5d;
	public static double minEMR = 0.125d;

	public static double maxD = 0.075d;
	public static double minD = 0.01d;
	
	public static int mutationSlots = 1000;
	public static double gradEMR = (maxEMR - minEMR)/mutationSlots;
	public static double gradD = (maxD - minD)/mutationSlots;
	
	
	
	int[] g1;
	int[] g2;
	int[] g3;
	int[] g4;
	int[] g5;
	
	public static final double killRate = 0.2d;
	public static double strongTiesThr = 66;
	public static double mediumTiesThr = 33;
	
	public static double rescouseWeight;
	public static double wellBeingWeight;	
	public static double riskWeight;
	public static double allianceWeight;	
	public static double stressWeight;
	
	public Sociaty() 
	{
		g1 = new int[generations + 1];
		g2 = new int[generations + 1];
		g3 = new int[generations + 1];
		g4 = new int[generations + 1];
		g5 = new int[generations + 1];
		g1[0] = 0;
		g2[0] = 300;
		g3[0] = 0;
		g4[0] = 0;
		g5[0] = 0;
		egoes = new ArrayList<Ego>();
		Ego ego = null;		
		int bias = 0;
		for(int i = 0; i < g1[0]; i++)
		{
			ego = new Ego(i + bias);
			ego.setStagePreferred();
			egoes.add(ego);
		}		
		bias += g1[0];
		for(int i = 0; i < g2[0]; i++)
		{
			ego = new Ego(i + bias);
			ego.setStrongTiesPreferred();
			egoes.add(ego);
		}
		bias += g2[0];
		for(int i = 0; i < g3[0]; i++)
		{
			ego = new Ego(i + bias);
			ego.setWeakTiesPreferred();
			egoes.add(ego);
		}
		bias += g3[0];
		for(int i = 0; i < g4[0]; i++)
		{
			ego = new Ego(i + bias);
			ego.setMediumTiesPreferred();
			egoes.add(ego);
		}
		bias += g4[0];
		for(int i = 0; i < g5[0]; i++)
		{
			ego = new Ego(i + bias);
			ego.setShufflePreferred();
			egoes.add(ego);
		}		
	
		setEatRatio();
		setMinDefectRate();
	}

	
	public void setEatRatio()
	{
		for(int i = 0; i < population; i++)
		{
			int index = (int)Math.floor(Math.random() * eatMeetGenesIni.length);
			egoes.get(i).setEatRatio(eatMeetGenesIni[index]);
		}
	}
	
//	public void setMinDefectRate()
//	{
//		for(int i = 0; i < population; i++)
//		{
//			int index = (int)Math.floor(Math.random() * DefectGenesIni.length);
//			egoes.get(i).setMinDefectRate(DefectGenesIni[index]);
//		} 
//	}

	public void setMinDefectRate()
	{
		for(int i = 0; i < population; i++)
		{
			int defectMode = (int)Math.floor(Math.random() * 4);
			egoes.get(i).setDefection(defectMode, constantDefectRate);
		} 
	}

	private void remove(Ego ego)
	{
		int removedID = ego.getID();
		for(int i = 0; i < egoes.size(); i++)
		{
			egoes.get(i).removeLog(removedID);
		}
		egoes.remove(ego);
	}
	public void reset()
	{
		//add kins
		if(averageNumberKins > 0)
		{
			for(int i = 0; i < population; i++)
			{
				if(egoes.get(i).getNumberKins() < averageNumberKins)
				{
					boolean cont = true;
					for(int j = i + 1; cont && j < population; j++)
					{
						if(egoes.get(j).getNumberKins() < averageNumberKins)
						{
							egoes.get(i).addKins(egoes.get(j));
							egoes.get(j).addKins(egoes.get(i));
							if(egoes.get(i).getNumberKins() < averageNumberKins)		
							{
								cont = true;
							}
							else
							{
								cont = false;
							}		
						}
					}
				}
			}
		}

		
		//reset and mutate
		for(int i = 0; i < population; i++)
		{
			egoes.get(i).reset();
			if(Math.random() < mutationRate)
			{
				egoes.get(i).mutate();
			}
		}
		
		//crossover
		Ego ego1 = null;
		Ego ego2 = null;
		for(int i = 0; i < population; i++)
		{
			if(Math.random() < crossoverRate)
			{
				if(ego1 == null)
				{
					ego1 = egoes.get(i);
				}
				else if(ego2 == null)
				{
					ego2 = egoes.get(i);
					crossover(ego1, ego2);
					ego1 = null;
					ego2 = null;					
				}
			}
		}
	}	

	public void crossover(Ego ego1, Ego ego2) 
	{		
		int div = 0;
		if(crossoverDe)
		{
			div++;
		}
		if(crossoverEM)
		{
			div++;
		}
		if(crossoverST)
		{
			div++;
		}
		double x = 1.0d / div;				
		double y = x;
		double rand = Math.random();
		boolean done = false;
		if(!done && crossoverST)
		{
			if(rand < y)
			{
				//crossover on strategy
				String strategy = ego1.getStrategy();
				ego1.setStrategy(ego2.getStrategy());
				ego2.setStrategy(strategy);
				done = true;
			}
			else
			{
				y += x;
			}			
		}
		if(!done && crossoverEM)
		{
			if(rand < y)
			{
				//crossover on eat meet ratio
				double rate = ego1.getEatMeetRatio();
				ego1.setEatRatio(ego2.getEatMeetRatio());
				ego2.setEatRatio(rate);
				done = true;
			}
			else
			{
				y += x;
			}	
		}

		if(!done && crossoverDe)
		{
			//crossover on defection rate
						
			int mode = ego1.getdefectMode();
			double rate = ego1.getConstantDefectRate();
			ego1.setDefection(ego2.getdefectMode(), ego2.getConstantDefectRate());
			ego2.setDefection(mode, rate);			
		}
	}
	
	public void run() 
	throws Exception
	{
egoes.get(50).setTrustTrace();
egoes.get(100).setTrustTrace();
egoes.get(150).setTrustTrace();
egoes.get(200).setTrustTrace();
egoes.get(250).setTrustTrace();
		String fileName = String.valueOf(rescouseWeight)+ "-" +
			String.valueOf(wellBeingWeight) + "-" +
			String.valueOf(allianceWeight) + "-" +
			String.valueOf(riskWeight) + "-" +
			String.valueOf(stressWeight + ".txt");
		fstream = new FileWriter(fileName);
        out = new BufferedWriter(fstream);
		
		
		int total = iterations * generations;
		double[] trustStrong = new double[total];
		double[] trustWeak = new double[total];
		double[] trustMedium = new double[total];
		double[] strongTies = new double[total];
		double[] weakTies = new double[total];
		double[] mediumTies = new double[total];
		
		double[] averageEatMeetRatio = new double[generations + 1];
		averageEatMeetRatio[0] = 0.26875;
		double[] averageDefectRatio = new double[generations + 1];
		averageDefectRatio[0] = 0.0475;
		
		double[][] trusts = new double[generations][population * population];
		double[][] trustFreq = new double[generations][100];
		
		
		for(int i = 0; i < generations; i++)
		{
			for(int j = 0; j < 100; j++)
			{
				trustFreq[i][j] = 0;
			}
		}
		
		Ego selectedEgo = null;
		int newIndex = population;
		
		String s = "index," +
		"average trust for strong ties," +
		"average trust for medium ties," +
		"average trust for weak ties," +
		"average strong ties, " +
		"average medium ties, " +
		"average weak ties," +
		"average total ties";
		
		if(DEBUG)
		{
			System.out.println(s);
		}		
		out.append(s + "\n");
		
		
		for(int k = 0; k < generations; k++)
		{
			reset();

			for(int i = 0; i < iterations; i++)
			{
				for(int j = 0; j < population; j++)
				{
					selectedEgo = egoes.get(j);
					selectedEgo.tiesDecay();
				}	
				
				int ik = k * iterations + i;
				trustStrong[ik] = 0;
				trustWeak[ik] = 0;
				trustMedium[ik] = 0;
				strongTies[ik] = 0;
				weakTies[ik] = 0;
				mediumTies[ik] = 0;
				
				
				for(int j = 0; j < population; j++)
				{
					selectedEgo = egoes.get(j);
					selectedEgo.runATurn(egoes, k, i);

					trustStrong[ik] += selectedEgo.getStrongTrust();
					trustWeak[ik] += selectedEgo.getWeakTrustWithMediumTies();
					trustMedium[ik] += selectedEgo.getMediumTrust();
					strongTies[ik] += selectedEgo.getStrongTies();
					weakTies[ik] += selectedEgo.getWeakTiesWithMudium();
					mediumTies[ik] += selectedEgo.getMediumTies();
				}			
				
				trustStrong[ik] /= population;
				trustWeak[ik] /= population;
				trustMedium[ik] /= population;
				strongTies[ik] /= population;
				weakTies[ik] /= population;
				mediumTies[ik] /= population;

//System.out.print(ik + ",");
//System.out.print(trustStrong[ik] + ",");
//System.out.print(trustMedium[ik] + ",");
//System.out.print(trustWeak[ik] + ",");
//System.out.print(strongTies[ik] + ",");
//System.out.print(mediumTies[ik] + ",");
//System.out.print(weakTies[ik] + ",");
//System.out.println((strongTies[ik]+mediumTies[ik]+weakTies[ik]));

		
			}
//
//			
//			for(int j = 0; j < population; j++)
//			{
//				selectedEgo = egoes.get(j);
//				selectedEgo.calculateFitness();
//			}			

			//for each generation; investigate the L shape relationship;
			//max trust = 100;
//			for(int i = 0; i < egoes.size(); i++)
//			{
//				List<MeetLOG> tmpLog = egoes.get(i).getAllMeetLog();
//				for(int j = 0; j < tmpLog.size(); j++)
//				{
//					double tmpTrust = tmpLog.get(j).getTrust();
//					if(tmpTrust > 0)
//					{
//						boolean cont = true;
//						for(int ii = 0; cont && ii < 100; ii++)
//						{
//							if(tmpTrust <= (ii + 1))
//							{
//								trustFreq[k][ii]++;
//								cont = false;
//							}
//						}
//					}
//					else
//					{
//						throw new Exception();
//					}
//				}		
//			}
//			
//			for(int ii = 0; ii < 100; ii++)
//			{
//				trustFreq[k][ii] /= (double)egoes.size();
//			}					
//			for(int ii = 98; ii >= 0; ii--)
//			{
//				trustFreq[k][ii] += trustFreq[k][ii + 1];	
//			}
//			System.out.println("***" + (k + 1) + "***");
//			System.out.println("trust, frequency");			
//			for(int ii = 0; ii < 100; ii++)
//			{
//				System.out.print((ii + 1) + ",");
//				System.out.println(trustFreq[k][ii]);
//			}
//			System.out.println();
			

			int ik = (k + 1) * iterations - 1;
			if(DEBUG)
			{
				System.out.print((k + 1) + ",");
				System.out.print(trustStrong[ik] + ",");
				System.out.print(trustMedium[ik] + ",");
				System.out.print(trustWeak[ik] + ",");
				System.out.print(strongTies[ik] + ",");
				System.out.print(mediumTies[ik] + ",");
				System.out.print(weakTies[ik] + ",");
				System.out.println((strongTies[ik]+mediumTies[ik]+weakTies[ik]));
			}			
			out.append((k + 1) + ",");				
			out.append(trustStrong[ik] + ",");				
			out.append(trustMedium[ik] + ",");			
			out.append(trustWeak[ik] + ",");			
			out.append(strongTies[ik] + ",");			
			out.append(mediumTies[ik] + ",");			
			out.append(weakTies[ik] + ",");			
			out.append((strongTies[ik]+mediumTies[ik]+weakTies[ik]) + "\n");
			
			if(k < generations - 1)
			{
				//selection
				//rank resource
				Ego[] egosResource = new Ego[population];
				for(int i = 0; i < population; i++)
				{
					egosResource[i] = egoes.get(i);
					
				}
				QuickSort.quickSort(egosResource, 0, population - 1, QuickSort.resource);
				double score = 1;
				for(int i = 0; i < population; i++)
				{
					egosResource[i].scoreResource = score;
					score++;
				}	
				//rank wellbeing
				Ego[] egosWellBeing = new Ego[population];			
				for(int i = 0; i < population; i++)
				{
					egosWellBeing[i] = egoes.get(i);					
				}
				QuickSort.quickSort(egosWellBeing, 0, population - 1, QuickSort.wellbeing);
				score = 1;
				for(int i = 0; i < population; i++)
				{
					egosWellBeing[i].scorewellbeing = score;
					score++;
				}							
				//rank alliance
				Ego[] egosAlliance = new Ego[population];			
				for(int i = 0; i < population; i++)
				{
					egosAlliance[i] = egoes.get(i);					
				}
				QuickSort.quickSort(egosAlliance, 0, population - 1, QuickSort.alliance);
				score = 1;
				for(int i = 0; i < population; i++)
				{
					egosAlliance[i].scoreAlliance = score;
					score++;
				}		
				//rank risk
				Ego[] egosRisk = new Ego[population];			
				for(int i = 0; i < population; i++)
				{
					egosRisk[i] = egoes.get(i);
				}
				QuickSort.quickSort(egosRisk, 0, population - 1, QuickSort.risk);
				score = population;
				for(int i = 0; i < population; i++)
				{
					egosRisk[i].scoreRisk = score;
					score--;
				}	
				//rank stress
				Ego[] egosStrss = new Ego[population];			
				for(int i = 0; i < population; i++)
				{
					egosStrss[i] = egoes.get(i);
				}
				QuickSort.quickSort(egosStrss, 0, population - 1, QuickSort.stress);
				score = population;
				for(int i = 0; i < population; i++)
				{
					egosStrss[i].scoreStress = score;
					score--;
				}	
				//rank score
				Ego[] egosScore = new Ego[population];			
				for(int i = 0; i < population; i++)
				{
					egosScore[i] = egoes.get(i);
				}
				QuickSort.quickSort(egosScore, 0, population - 1, QuickSort.overall);


				for(int i = 0; i < population * killRate; i++)
				{				
					remove(egosScore[i]);
				}		

				//breeding
				for(int i = 0; i < population * killRate; i++)
				{
					Ego ego = new Ego(newIndex, egosScore[population - i - 1]);
					egoes.add(ego);
					newIndex++;
				}
				
				for(int i = 0; i < egoes.size(); i++)
				{
					if(egoes.get(i).isStagePreferred())
					{
						g1[k + 1]++;
					}
					else if(egoes.get(i).isStrongTiesPreferred())
					{
						g2[k + 1]++;
					}
					else if(egoes.get(i).isWeakTiesPreferred())
					{
						g3[k + 1]++;
					}
					else if(egoes.get(i).isMediumTiesPreferred())
					{
						g4[k + 1]++;
					}
					else if(egoes.get(i).isShufflePreferred())
					{
						g5[k + 1]++;
					}
					
					averageEatMeetRatio[k + 1] += egoes.get(i).getEatMeetRatio();
//					averageDefectRatio[k + 1] += egoes.get(i).getDefectRate();
				}
				averageEatMeetRatio[k + 1] /= population;
				averageDefectRatio[k + 1] /= population;
			}

		}
		
		if(DEBUG)
		{
			System.out.println();
			System.out.println();
		}
		out.append("\n\n");
		
		s = "generation,stage preferred,strong preferred, weak preferred, medium preferred" +
		",shuffle preferred";
		if(DEBUG)
		{
			System.out.println(s);
		}
		out.append(s + "\n");
		
		for(int i = 0; i < generations; i ++)
		{
			if(DEBUG)
			{
				System.out.print((i + 1) + ",");
				System.out.print(String.valueOf(g1[i]) + ",");
				System.out.print(String.valueOf(g2[i]) + ",");
				System.out.print(String.valueOf(g3[i]) + ",");
				System.out.print(String.valueOf(g4[i]) + ",");
				System.out.println(String.valueOf(g5[i]));
			}
			out.append((i + 1) + ",");
			out.append(String.valueOf(g1[i]) + ",");
			out.append(String.valueOf(g2[i]) + ",");
			out.append(String.valueOf(g3[i]) + ",");
			out.append(String.valueOf(g4[i]) + ",");
			out.append(String.valueOf(g5[i]) + "\n");
		}		

		if(DEBUG)
		{
			System.out.println();
			System.out.println();
		}
		out.append("\n\n");
		s = "generation,average eat/meet ratio,min defect rate";		
		if(DEBUG)
		{
			System.out.println(s);
		}
		out.append(s + "\n");
		for(int i = 0; i < generations; i ++)
		{
			if(DEBUG)
			{
				System.out.print((i + 1) + ",");
				System.out.print(String.valueOf(averageEatMeetRatio[i]) + ",");
				System.out.println(String.valueOf(averageDefectRatio[i]));
			}
			out.append((i + 1) + ",");
			out.append(String.valueOf(averageEatMeetRatio[i]) + ",");
			out.append(String.valueOf(averageDefectRatio[i]) + "\n");
		}		
		
		double finalWeakTies = weakTies[weakTies.length - 1];
		double finalMediumTies = mediumTies[mediumTies.length - 1];
		double finalStrongTies = strongTies[strongTies.length - 1];
		double finalAllties = finalWeakTies + finalMediumTies + finalStrongTies;
		if((finalAllties > 140 && finalAllties < 160)
				&& (finalMediumTies > 12 && finalMediumTies < 18)
				&&(finalStrongTies > 4 && finalStrongTies < 8))
		{
			SBH = true;
		}
		else
		{
			SBH = false;
		}
		

		if(DEBUG)
		{
			System.out.print("\n\nSBH="+SBH);
		}
		out.append("\n\nSBH="+SBH);
		
		
		int[] count = new int[4];
		for(int i = 0; i < 4; i++)
		{
			count[i] = 0;
		}
		for(int i = 0; i < egoes.size(); i++)
		{
			count[egoes.get(i).getdefectMode()]++;
		}
		
 
		if(DEBUG)
		{
			System.out.println();
			System.out.println();
			System.out.println("always cooperate: "+ count[0]);
			System.out.println("defect = " + constantDefectRate + ": " + count[1]);
			System.out.println("defect linearly: "+ count[2]);
			System.out.println("defect logly: "+ count[3]);
		}
		out.append("\n\nalways cooperate: "+ count[0]);
		out.append("defect = " + constantDefectRate + ": " + count[1] + "\n");
		out.append("defect linearly: "+ count[2] + "\n");
		out.append("defect logly: "+ count[3] + "\n");		
		out.close();


egoes.get(50).debudPrintTrust();
egoes.get(100).debudPrintTrust();
egoes.get(150).debudPrintTrust();
egoes.get(200).debudPrintTrust();
egoes.get(250).debudPrintTrust();


		

		System.out.println("finished");
//		System.out.println();
//		System.out.println();
//		
//		List<MeetLOG> log = null;
//		double index = 0;
//		double contant = 1.0d / (double)population;
//		for(int i = 0; i < population; i++)
//		{
//			log = egoes.get(i).getMeetLog();
//			for(int j = 0; j < log.size(); j++)
//			{
//				System.out.println(index + "," +log.get(j).getTrust());
//				index = index + contant;
//			}
//			
//		}
		
	}	
}
