package acac;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.awt.Shape;
import java.awt.geom.AffineTransform;
import java.awt.geom.Path2D;

import javax.swing.JFrame;
import javax.swing.JPanel;

public class Vslzer extends JPanel 
{

	/**
	 * @param args
	 */
	double theta = 0;
	private static final int horizontal = 0;
	private static final int vertical = 1;
	private static final double angle = Math.toRadians(20);//angle of the arrow head
	private static final int barb = 10;
	static Path2D.Double x;
	static Path2D.Double y;
	static Path2D.Double resource;
	static Path2D.Double wellbeing;
	static Path2D.Double alliance;
	static Path2D.Double risk;
	static Path2D.Double stress;
	
	private static final int xStart = -150;
	private static final int yStart = 50;
	private static final int xLength = 300;
	private static final int yLength = 120;	
	private static final int xInterval = 50;
	private static final int yInterval = 20;	
	private static final int ruler = 5;
	

	private static final int LabelX = 150;
	private static final int LabelY = -69;
	private static final int labelInterval = 13;	
	static Path2D.Double[] labels = new Path2D.Double[7];
	
	

	static Path2D.Double[][] freqLines = new Path2D.Double[4][];	
	static int[][] freqLinesWides = new int[4][];
	
	private static final int[][] sbh = 
	{{1,5,1,1,1}
	,{2,5,2,1,1}
	,{3,5,5,3,1}
	,{4,5,5,2,1}
	,{1,2,4,1,3}
	,{1,2,4,2,2}
	,{1,2,5,1,4}
	,{1,2,5,2,3}
	,{1,4,4,1,4}
	,{1,4,5,1,5}
	,{1,4,5,2,4}
	,{2,2,5,1,3}
	,{1,2,5,3,2}
	,{1,2,5,4,1}
	,{1,4,4,3,2}
	,{1,4,5,3,3}
	,{1,4,5,4,2}
	,{1,4,5,5,1}
	,{3,3,4,1,1}
	,{3,5,3,1,1}
	,{3,5,4,1,2}};
/*	
	resource	wellBeing	alliance	risk	stress
	1	5	1	1	1
	2	5	2	1	1
	3	5	5	3	1
	4	5	5	2	1
	1	2	4	1	3
	1	2	4	2	2
	1	2	5	1	4
	1	2	5	2	3
	1	4	4	1	4
	1	4	5	1	5
	1	4	5	2	4
	2	2	5	1	3
	1	2	5	3	2
	1	2	5	4	1
	1	4	4	3	2
	1	4	5	3	3
	1	4	5	4	2
	1	4	5	5	1
	3	3	4	1	1
	3	5	3	1	1
	3	5	4	1	2
*/
	
    protected void paintComponent(Graphics g) {
        super.paintComponent(g);
        Graphics2D g2 = (Graphics2D) g;
        setBackground(Color.white);
        g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
                RenderingHints.VALUE_ANTIALIAS_ON);
        int cx = getWidth() / 2;
        int cy = getHeight() / 2;
        AffineTransform at = AffineTransform.getTranslateInstance(cx, cy);
        at.rotate(theta);
        at.scale(2.0, 2.0); //width and height
        Shape x = at.createTransformedShape(this.x);
        Shape y = at.createTransformedShape(this.y);
        Shape resource = at.createTransformedShape(this.resource);
        Shape wellbeing = at.createTransformedShape(this.wellbeing);
        Shape alliance = at.createTransformedShape(this.alliance);
        Shape risk = at.createTransformedShape(this.risk);
        Shape stress = at.createTransformedShape(this.stress);
        g2.setPaint(Color.blue);
        g2.draw(x);
        g2.draw(y);
        g2.draw(resource);
        g2.draw(wellbeing);
        g2.draw(alliance);
        g2.draw(risk);
        g2.draw(stress);
        
        Shape[][] lines = new Shape[4][];
        for(int i = 0; i < 4; i++)
        {
        	lines[i] = new Shape[freqLines[i].length];
        	for(int j = 0; j < freqLines[i].length; j++)
        	{
        		try 
        		{
					g2.setPaint(getColor(freqLinesWides[i][j]));
				} catch (Exception e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
        		lines[i][j] = at.createTransformedShape(freqLines[i][j]);
                g2.draw(lines[i][j]);
        	}
        }    
        
        Shape[] labels = new Shape[7];
        for(int i = 0; i < 7; i++)
        {
        	try 
        	{
				g2.setPaint(getColor(i+1));
				labels[i] = at.createTransformedShape(this.labels[i]);
				g2.draw(labels[i]);
			}
        	catch (Exception e1) 
        	{
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
        }    
        
        addRuler(g2);  
        addLabelText(g2);   
        try 
        {
			DrawLabel(g2, at);
		} 
        catch (Exception e) 
        {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
    }

    private void addRuler(Graphics2D g2)
    {
        g2.setPaint(Color.blue);    
        int x = 85;
        int y = 285;
        for(int i = 0; i <= 5; i++)
        {
        	g2.drawString(String.valueOf(i), x, y);
        	y -= 40;
        }
        
        String[] lable = {"resource", "wellbeing", "alliance", "risk", "stress"};

        x = 170;
        y = 295;
    	g2.drawString(lable[0], x, y);
    	x += 100;
    	g2.drawString(lable[1], x, y);
    	x += 105;
    	g2.drawString(lable[2], x, y);
    	x += 112;
    	g2.drawString(lable[3], x, y);
    	x += 92;
    	g2.drawString(lable[4], x, y);
    }
    

    private void addLabelText(Graphics2D g2)
    {
        g2.setPaint(Color.blue);    
        int x = 650;
        int y = 50;        
        String[] label = {"freq = 1", "freq = 2", "freq = 3", "freq = 4", "freq = 5",
        		"freq = 6", "freq = 7"};
        for(int i = 0; i < label.length; i++)
        {
        	g2.drawString(label[i], x, y);
        	y += 26;
        }
    }
    
    private void DrawLabel(Graphics2D g2, AffineTransform at) throws Exception
    {

    }

    private Color getColor(int i) throws Exception
    {
    	switch(i)
    	{
    		case 1: return Color.yellow;
    		case 2: return Color.orange;
    		case 3: return Color.pink;
    		case 4: return Color.red;
    		case 5: return Color.gray;
    		case 6: return Color.darkGray;
    		case 7: return Color.black;
    		default: throw new Exception();
    	}    	
    }

    static private Path2D.Double createLabel(int i) 
    {

	    int x = LabelX;
		int y = LabelY + i * labelInterval;
	    Path2D.Double path = new Path2D.Double();
	    path.moveTo(x, y);
	    path.lineTo(x + 10, y);
	    return path;
    }
    
    static private Path2D.Double createArrow(
    		int startX, int startY, int length, int orientation) 
	{
	    Path2D.Double path = new Path2D.Double();
	    double x = startX;
	    double y = startY;
		if(orientation == horizontal)
		{
	        for(int i = 1; i <= 5; i++)
	        {
	        	path.moveTo(x + xInterval * i, y);
	        	path.lineTo(x + xInterval * i, y - ruler);
	        }
	        
	        path.moveTo(x, y);
			x += length;
	        path.lineTo(x, y);	        
	        path.lineTo(x - barb * Math.cos(angle), y + barb * Math.sin(angle));
	        path.moveTo(x - barb * Math.cos(angle), y - barb * Math.sin(angle));
	        path.lineTo(x, y);
		}
		else if(orientation == vertical)
		{
	        for(int i = 1; i <= 5; i++)
	        {
	        	path.moveTo(x, y - i * yInterval);
	        	path.lineTo(x + ruler, y - i * yInterval);
	        }
	        path.moveTo(x, y);
			y -= length;
	        path.lineTo(x, y);	     
	        path.lineTo(x + barb * Math.sin(angle), y + barb * Math.cos(angle));
	        path.moveTo(x - barb * Math.sin(angle), y + barb * Math.cos(angle));
	        path.lineTo(x, y);	        
		}

	    return path;
	}
    
    static private Path2D.Double createLine(int startX, int startY, int length, int orientation) 
	{
	    Path2D.Double path = new Path2D.Double();
        path.moveTo(startX, startY);
		if(orientation == horizontal)
		{
	        path.lineTo(startX + length, startY);
		}
		else if(orientation == vertical)
		{
	        path.lineTo(startX, startY - length);
		}
	    return path;
	}
    
    static private int[][] calculateFrequency(int pos)
    {
    	int[][] tmpFreq = new int[20][3];
    	int count = -1;
    	for(int i = 0; i < sbh.length; i++)
    	{
    		boolean cont = true;
    		for(int j = 0; cont && j <= count; j++)
    		{
    			if(sbh[i][pos] == tmpFreq [j][0]&& 
    					sbh[i][pos + 1] == tmpFreq [j][1])
    			{
    				tmpFreq [j][2]++;
    				cont = false;
    			}
    		}
    		if(cont)
    		{
    			count++;
    			tmpFreq [count][0] = sbh[i][pos];
    			tmpFreq [count][1] = sbh[i][pos + 1];
    			tmpFreq [count][2] = 1;
    		}
    	}
    	count++;
    	
    	int[][] freq = new int[count][3];
    	for(int i = 0; i < count; i++)
    	{
    		for(int j = 0; j < 3; j++)
    		{
    			freq[i][j] = tmpFreq[i][j];
    		}
    	}   
    	return freq;    	
    }
    

    static private Path2D.Double createFrequencyLine(int i, int j, int[] freq)
    {
	    Path2D.Double path = new Path2D.Double();
	    int x = xStart + (i + 1) * xInterval;
	    int y = yStart - (freq[0]) * yInterval;
        path.moveTo(x, y);
        
	    int x1 = xStart + (i + 2) * xInterval;
	    int y1 = yStart - (freq[1]) * yInterval;
	    path.lineTo(x1, y1);
	    
	    freqLinesWides[i][j] = freq[2];
	    return path;
    }
	
	public static void main(String[] args) 
	{

		
	    x = createArrow(xStart, yStart, xLength, horizontal);
	    y = createArrow(xStart, yStart, yLength, vertical);
	    resource = createLine(xStart + xInterval, yStart, yLength, vertical);
	    wellbeing = createLine(xStart + 2 * xInterval, yStart, yLength, vertical);
	    alliance = createLine(xStart + 3 * xInterval, yStart, yLength, vertical);
	    risk = createLine(xStart + 4 * xInterval, yStart, yLength, vertical);
	    stress = createLine(xStart + 5 * xInterval, yStart, yLength, vertical);	    
	    
	    for(int i = 0; i < 4; i++)
	    {
	    	int[][] freq = calculateFrequency(i);
	    	freqLines[i] = new Path2D.Double[freq.length];	 
	    	freqLinesWides[i] = new int[freq.length];
	    	for(int j = 0; j < freq.length; j++)
	    	{
	    		freqLines[i][j] = createFrequencyLine(i, j, freq[j]);
	    	}
	    }
	    
	    for(int i = 0; i < 7; i++)
	    {
	    	labels[i] = createLabel(i);
	    }
	    
	    Vslzer test = new Vslzer();
	    JFrame f = new JFrame();
	    f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	    f.add(test);
	    f.setSize(800, 400);
	    f.setLocationRelativeTo(null);
	    f.setVisible(true);	 
	 }

}
